# Copyright 2021-2023 H2020 TeraFlow (https://www.teraflow-h2020.eu/)
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from sqlalchemy import Column, ForeignKey, String
from sqlalchemy.dialects.postgresql import UUID
from sqlalchemy.orm import relationship
from typing import Dict
from ._Base import _Base

class TopologyModel(_Base):
    __tablename__ = 'topology'

    topology_uuid = Column(UUID(as_uuid=False), primary_key=True)
    context_uuid  = Column(ForeignKey('context.context_uuid'), nullable=False)
    topology_name = Column(String, nullable=False)

    context          = relationship('ContextModel', back_populates='topologies')
    topology_devices = relationship('TopologyDeviceModel') # back_populates='topology'
    topology_links   = relationship('TopologyLinkModel'  ) # back_populates='topology'

    def dump_id(self) -> Dict:
        return {
            'context_id': self.context.dump_id(),
            'topology_uuid': {'uuid': self.topology_uuid},
        }

    def dump(self) -> Dict:
        return {
            'topology_id': self.dump_id(),
            'name'       : self.topology_name,
            'device_ids' : [{'device_uuid': {'uuid': td.device_uuid}} for td in self.topology_devices],
            'link_ids'   : [{'link_uuid'  : {'uuid': tl.link_uuid  }} for tl in self.topology_links  ],
        }

class TopologyDeviceModel(_Base):
    __tablename__ = 'topology_device'

    topology_uuid = Column(ForeignKey('topology.topology_uuid', ondelete='RESTRICT'), primary_key=True)
    device_uuid   = Column(ForeignKey('device.device_uuid',     ondelete='CASCADE' ), primary_key=True)

    #topology = relationship('TopologyModel', lazy='joined') # back_populates='topology_devices'
    device   = relationship('DeviceModel',   lazy='joined') # back_populates='topology_devices'

class TopologyLinkModel(_Base):
    __tablename__ = 'topology_link'

    topology_uuid = Column(ForeignKey('topology.topology_uuid', ondelete='RESTRICT'), primary_key=True)
    link_uuid     = Column(ForeignKey('link.link_uuid',         ondelete='CASCADE' ), primary_key=True)

    #topology = relationship('TopologyModel', lazy='joined') # back_populates='topology_links'
    link     = relationship('LinkModel',     lazy='joined') # back_populates='topology_links'
